<?php
Class MssqlClass{
	Private $typesNotLength = array('sql_variant','ntext','sysname','bit','bigint','image','timestamp','money','smallmoney','int','smallint','real');

	Public function connect($server,$username,$password){
	  $conn = @mssql_connect($server,$username,$password);
	  return $conn;
	}
	
	Public function close($conn){
		@mssql_close($conn);
	}
	
	Public function setDB($nameDB){
		mssql_select_db($nameDB);
	}
	
	//server/////////////////////////////////////////////////////////
	Public function getDatabases(){
		$db_list = $this->getRowsQuery("sp_databases");
		$pocet = count($db_list);
		for($i=0;$i<$pocet;$i++){
		  	$result[] = $db_list[$i][0];
		}
		return $result;
	}
	
	Public function getStatus($connection){
		$result["infoStat"] = "";
		$result["verzeServeru"] = mssql_result(mssql_query("select @@version as version"),0,"version");
		$result["host"] = mssql_result(mssql_query("select @@servername as serverName"),0,"serverName");
		return $result;
	}
	
	Public function getTables($database){
		$this->setDB($database);
		$result = $this->getRowsQuery("sp_tables");
		if(count($result) == 0){
		    $vysl[] = "Nenalezeny dn tabulky!";	
		}
		else{
		 foreach($result as $key){
		  $vysl[] = $key[2];	
		 }
		}
		return $vysl;
	}
	
	Public function getTablesDetailed($database){
		$result = $this->getRowsQuery("sp_tables @table_qualifier = '$database'");
		return $result;
	}
	
	Public function getCharacterSets(){
		$result = $this->getRowsQuery("sp_enumcodepages");
		return $result;
	}
	
	Public function getCollation(){
		$result = $this->getRowsQuery("SELECT * FROM ::fn_helpcollations()"); // WHERE name LIKE '$characterSet%'");
		return $result;
	}
	
	Public function getDataTypes(){
		$result = $this->getRowsQuery("sp_datatype_info");
		foreach($result as $type){
			if(!eregi("^.+ident.+$",$type[12])){
			$vysl[] = $type[12];
			}
		}
		return $vysl;
	}
	//query/////////////////////////////////////////////////////////
	Public function getRowsQuery($dotaz){
		$result = @mssql_query($dotaz);
		$vysl = array();
		while ($line = @mssql_fetch_row($result)){
			$vysl[] = $line;
		}
		if(count($vysl) == 0){$vysl[] = array("Nebyly nalezeny dn zznamy!");}
		return @$vysl;
	}
	
	Public function getResultSQL($query){
		$test_vyrazu = eregi("^[[:blank:]]*(delete|insert|create|grant )",$query);
		if ($test_vyrazu == 0){
			$content = @mssql_query($query);
			if (!$content){
 				$return = array('fields'=>array("Chyba v SQL dotazu"), 'content'=>array(array(@mssql_get_last_message())));	
 			}
 			else{
 				$num_rows = mssql_num_rows($content);
 				$num_fields = mssql_num_fields($content);
 				$i = 0;	
 				while ($i < $num_fields){
  				$fields[] = mssql_field_name($content,$i);
  				$i++;
  				}
  				while ($line = mssql_fetch_row($content)){
				$vysl[] = $line;
				}
				$return = array('fields'=>$fields, 'content'=>$vysl);
 			}
 				
		}
		else{
			$content = $this->simpleQuery($query);
			$return = array('fields'=>array("Vsledek dotazu"), 'content'=>array(array($content)));			
		}
		
		return $return;
	}
	
	Public function simpleQuery($dotaz){
		$result = @mssql_query($dotaz);
		$return = mssql_get_last_message();
		return $return;
	}
	//DB/////////////////////////////////////////////////////////
	Public function createDB($name, $collation){
		$result = $this->simpleQuery("CREATE DATABASE $name COLLATE $collation");
		return $result;
	}
	
	Public function dropDB($name){
		$result = $this->simpleQuery("DROP DATABASE $name");
		return $result;
	}
	
	Public function renameDB($oldName, $newName){
		$result = $this->simpleQuery("sp_renamedb @dbname = '$oldName' , @newname = '$newName'");
		return $result;
	}
	//table/////////////////////////////////////////////////////////
	Public function createTable($tableName, $columns){
		$createStr = "CREATE TABLE $tableName (";
		foreach ($columns as $key){
		 $createStr .= " ".$key['name']." ".$key['type'];
		 if (!in_array($key['type'], $this->typesNotLength) AND $key['length'] != ""){
		 	$createStr .= " (".$key['length'].") ";
		 }
		 $createStr .= " ".$key['null'];
		 if ($key['default'] != ""){$createStr .= " DEFAULT '".$key['default']."'";}
		 if ($key['flags'] !=""){$createStr .= " IDENTITY(1,1)";}
		 if ($key['primaryKey'] !=""){$createStr .= " PRIMARY KEY";}
 		 $createStr .= ",";
		}
		
		$createStr = substr($createStr, 0, -1);
		$createStr .= ")";
		
		echo $createStr."<br />";
		$result = $this->simpleQuery($createStr);
		return $result;
	}
	
	Public function truncateTable($tableName){
		$result = $this->simpleQuery("TRUNCATE TABLE $tableName");
		return $result;
	}
	
	Public function dropTable($tableName){
		$result = $this->simpleQuery("DROP TABLE $tableName");
		return $result;
	}
	
	Public function renameTable($oldName, $newName){
		$result = $this->simpleQuery("sp_rename '$oldName', '$newName'");
		return $result;
	}
		
	Public function describeTable($tableName,$db){
		$this->setDB($db);
		$result = $this->getRowsQuery("sp_columns @table_name = '$tableName'");
		if(count($result) == 0){
		    $vysl[] = array("Nenalezeny"," dn", " sloupce!");	
		}
		else{
		 foreach($result as $key){
		 	$default = substr(substr(trim($key[12]),2),0,-2);
			@$vysl[] = array($key[3],$key[5]."(".$key[7].")",$key[17],$default);
		 }
		}
		return $vysl;
	}
	
		
	//columns/////////////////////////////////////////////////////////
	Public function getColumns($table){
		$result = $this->getRowsQuery("sp_columns @table_name = '$tableName'");
		return $result;
	}
	
	Public function addColumns($table,$columns){
		$createStr = "ALTER TABLE $table ADD ";
		foreach ($columns as $key){
		 $createStr .= " ".$key['name']." ".$key['type'];
		 if (!in_array($key['type'], $this->typesNotLength) AND $key['length'] != ""){
		 	$createStr .= " (".$key['length'].") ";
		 }
		 $createStr .= " ".$key['null'];
		 if ($key['default'] != ""){$createStr .= " DEFAULT '".$key['default']."'";}
		 if ($key['flags'] !=""){$createStr .= " IDENTITY(1,1)";}
		 if ($key['primaryKey'] !=""){$createStr .= " PRIMARY KEY";}
 		 $createStr .= ",";
		}
		
		$createStr = substr($createStr, 0, -1);
		
		echo $createStr."<br />";
		$result = $this->simpleQuery($createStr);
		return $result;
	}
	
	Public function dropColumn($table,$nameCol){
		echo "ALTER TABLE $table DROP COLUMN $nameCol";
		$result = $this->simpleQuery("ALTER TABLE $table DROP COLUMN $nameCol");
		return $result;
	}
	
	Public function alterColumn($table,$columns){
		$createStr = "ALTER TABLE $table ALTER COLUMN ";
		$createStr .= " ".$columns['name']." ".$columns['type'];
		 if (!in_array($columns['type'], $this->typesNotLength) AND $columns['length'] != ""){
		 	$createStr .= " (".$columns['length'].") ";
		 }
		 $createStr .= " ".$columns['null'];
		 //if ($columns['default'] != ""){$createStr .= " DEFAULT '".$columns['default']."'";}
		 if ($columns['flags'] != ""){$createStr .= " IDENTITY(1,1)";}
		 if ($columns['primaryKey'] != ""){$createStr .= " PRIMARY KEY";}
 		 $createStr .= ",";
		
		$createStr = substr($createStr, 0, -1);
		
		echo $createStr."<br />";
		$result = $this->simpleQuery($createStr)."<br />";
		
		if ($columns['default'] != ""){
		$result = $this->simpleQuery("ALTER TABLE $table ADD CONSTRAINT DF__".$columns['name']." DEFAULT '".$columns['default']."' FOR ".$columns['name']);
		}
		
		return $result;
	}
	
	Public function getTypeColumn($tableName,$column){
		$return = mssql_result(mssql_query("sp_columns @table_name = '$tableName', @column_name = '$column'"),0,"TYPE_NAME");
		return $return;	
	}
	
	Public function getPrimaryKey($tableName){
		$return = $this->getRowsQuery("sp_pkeys @table_name = '$tableName'");
		return @trim($return[0][3]);
	}
	
	Public function dropDF($tableName,$fieldName){
		$return = $this->getRowsQuery("SELECT object_name(cdefault) FROM syscolumns WHERE id = object_id('$tableName') AND name = '$fieldName'");
		$return = $this->simpleQuery("ALTER TABLE $tableName DROP CONSTRAINT ".$return[0][0]);
		return $return;	
	}
	
	Public function getColumnDetail($tableName,$column){
		$return = $this->getRowsQuery("sp_columns @table_name = '$tableName', @column_name = '$column'");
		$primaryKey = $this->getPrimaryKey($tableName);
		if($column == $primaryKey){$primaryKey = 'YES';}
		else{$primaryKey = 'NO';}
		$return = $return[0];
		if(eregi("^.+ident.+$",$return[5])){
			$typ = split(" ",$return[5]);
			$typ = $typ[0];
			$increment = 'YES';}
		else{
			$typ = $return[5];
			$increment = 'NO';
		}
		$default = substr(substr(trim($return[12]),2),0,-2);
		$return = array($return[3],$typ,$return[7],$return[17],$default,$increment,$primaryKey);
		return $return;
	}
	
	Public function createItem($tableName,$columns,$values){
		$createStr = "";
		foreach($values as $row){
			$createStr .= "INSERT INTO $tableName (";
			$counter = 1;
			foreach($columns as $column){
			if(!eregi("^.+ident.+$",$this->getTypeColumn($tableName,$column))){$createStr .= "$column,";}
			else{$rowIdent = $counter - 1;};
			$counter++;
			}
			$createStr = substr($createStr, 0, -1);
			$createStr .= ") VALUES";
			$counter = 0;
			
				$createStr .= " (";
				foreach($row as $item){
					if($counter != $rowIdent){$createStr .= "'$item',";}
					$counter++;
				}
				$createStr = substr($createStr, 0, -1);
				$createStr .= ");";
		}
		$createStr = substr($createStr, 0, -1);
		
		echo $createStr."<br />";
		$result = $this->simpleQuery($createStr);
		return $result;
	}
	
	Public function delItem($table, $heads, $items){
		$delStr = "DELETE FROM $table WHERE ";
		for($i = count($heads);$i<$heads;$i++){
			$toDel[] = $heads[$i]."='".$items[$i]."'";
		}
		$delStr .= implode(" AND ",$toDel);
		echo "<br />".$delStr."<br />";
		$result = $this->simpleQuery($delStr);
		return $result;		
	}
	
	Public function updateItem($table, $heads, $itemsOld, $itemsNew){
		$updStr = "UPDATE $table SET ";
		$counter = 1;
		foreach($heads as $head){
		 if(eregi("^.+ident.+$",$this->getTypeColumn($table,$head))){$rowIdent = $counter - 1;}
		 $counter++;
		}
		for($i=0;$i<count($heads);$i++){
			if($i != $rowIdent){
			$toUpd[] = $heads[$i]."='".$itemsNew[$i]."'";
			}
		}
		$updStr .= implode(", ",$toUpd);
		$toUpd = array();
		$updStr .= " WHERE ";
		for($i=0;$i<count($heads);$i++){
			$toUpd[] = $heads[$i]."='".$itemsOld[$i]."'";
		}
		$updStr .= implode(" AND ",$toUpd);
		echo "<br />".$updStr."<br />";
		$result = $this->simpleQuery($updStr);
		return $result;	
	}
	//users/////////////////////////////////////////////////////////
	Public function createUser($userName,$password){
		$createStr = "sp_addlogin @loginame = '$userName' ";
		if(trim($password) != ""){
			$createStr .= " @passwd = '$password'";
		}
		$this->simpleQuery("sp_adduser @loginame = '$userName'");
		$this->simpleQuery("sp_grantdbaccess @loginame = '$userName'");
		
		$result = $this->simpleQuery($createStr);
		return $result;
	}
	
	Public function getUsers(){
		$getStr = "sp_helpuser";
		$result = $this->getRowsQuery($getStr);
		foreach($result as $item){
		$vysl[] = array($item[0],$item[2],'', '');
		}
		return $vysl;
	}
	
	Public function granPrivileges($user,$database,$privilegesDB,$privilegesAll){
		$this->simpleQuery("REVOKE ALL ON $database FROM $user");
		if(!empty($privilegesDB)){
			$grandStr = "GRANT ";
			$grandStr .= implode(",",$privilegesDB); 
			/*foreach($privilegesDB as $key){
				$grandStr .= " $key,";
			}
			$grandStr = substr($grandStr, 0, -1);*/
			$grandStr .= " ON $database TO $user";
			echo $result = $this->simpleQuery($grandStr)."<br />";
		}
		
		echo $grandStr."<br />";
		
		$grandStr = '';
		if(!empty($privilegesAll)){
			$grandStr = "GRANT ";
			$grandStr .= implode(",",$privilegesAll); 
			/*foreach($privilegesAll as $key){
				$grandStr .= " $key,";
			}
			$grandStr = substr($grandStr, 0, -1);*/
			$grandStr .= " ON $database TO $user";
			echo $result = $this->simpleQuery($grandStr)."<br />";
		}
		echo $grandStr;

		return $result;
	}
	
	Public function dropUser($userName){
		$result = $this->simpleQuery("sp_droplogin @loginame = '$userName'");
		return $result;
	}
	
	Public function exportDB($dbName, $path){
		$result = $this->simpleQuery("BACKUP DATABASE $dbName TO DISK = '".$path."/".$dbName.".dat'");
		return $result;
	}
	
	Public function importDB($dbName, $path){
		$result = $this->simpleQuery("use master; RESTORE DATABASE $dbName FROM DISK = '".$path."/".$dbName.".dat'");
		return $result;
	}
	//import/export
	//BACKUP DATABASE sadfasdfasf TO DISK = 'c:\MyNwind.dat'
	//use master; RESTORE DATABASE sadfasdfasf FROM DISK = 'c:\MyNwind.dat'
}
?>

