<?php

Class XmlConfig {
      Private $domConf,$server;
      
	/* konstruktor tdy XmlConfig
	 * jestlie soubor s konfigurac existuje, nate ho
	 * pokud ne, vytvo ho a v nm zkladn strukturu 
	 * */
	public function __construct()
	{
        if (file_exists("config.xml")) {
            $this->domConf = DOMDocument::load("config.xml");
        } 
        else {
        	$this->domConf = new DOMDocument('1.0', 'UTF-8');
            $root = $this->domConf->createElement('setup');
            $this->domConf->appendChild($root);
            $servers = $this->domConf->createElement('servers');
            $root->appendChild($servers);
            $includes = $this->domConf->createElement('including_classes');
            $root->appendChild($includes);                
            $includeClasses = array('libs/MysqlLib.php','libs/MssqlLib.php','libs/RegSrvLib.php','libs/ViewDBLib.php','libs/LeftMenuLib.php','libs/ContentLib.php','libs/TopMenuLib.php','libs/RenameDBLib.php','libs/SQLLib.php','libs/InfosLib.php','libs/DeleteLib.php','libs/CreateLib.php','libs/UserLib.php','libs/EditLib.php','libs/MidleftLib.php','libs/ImpExpLib.php');
            foreach ($includeClasses as $key){
               $include = $this->domConf->createElement('class');
               $include->setAttribute('value',$key);
               $includes->appendChild($include);
            }
            $this->domConf->save("config.xml");
        } 
    } 
    
    /* getNode($name as string)
     * $name: nzev uzlu
     * zsk pole uzl XML se jmnem $name
     * */
   public function getNode($name){
      return $this->domConf->getElementsByTagName($name);
   }
   
   /* createServer($name as string, $attributes as array(of string))
    * $name: nzev serveru
    * $attributes: 2xN pole atrtibut
    * vytvo do konfiguranho souboru nov server se jmnem $name
    * pid atributy z pole $attributes(jmnoAtributu, hodnotaAtributu)
    * */
   public function createServer($name,$attributes){
      $this->server = $this->getNode('servers');
      $new_server = $this->domConf->createElement($name);
      foreach($this->server as $key){
      $key->appendChild($new_server);
      	$new_server->setAttribute('Name',$attributes['Name']);
      	$new_server->setAttribute('Login',$attributes['Login']);
      	$new_server->setAttribute('Psw',$attributes['Psw']);
      	$new_server->setAttribute('Typ',$attributes['Typ']);
      }
      $this->saveConf();
   }
   
   public function getServerDet($name){
   	$this->server = $this->getNode('server');
   	$detaily = array();
   	foreach($this->server as $key){
   		if($key->getAttribute('Name') == $name){
   			$detaily = array('Name'=>$key->getAttribute('Name'),
   							 'Login'=>$key->getAttribute('Login'),
   							 'Psw'=>$key->getAttribute('Psw'),
   							 'Typ'=>$key->getAttribute('Typ'));
   		}
   	}
   	return $detaily;
   }
   
   /* getAttribute($node as node, $attrName as string)
    * $node: uzel v XML
    * $attrName: nzev atributu
    * zsk hodnotu atrubutu v uzlu
    * */
   public function getAttribute($node,$attrName){
      //$item = $this->domConf->getElementsByTagName($node);
      $value = $node->getAttribute($attrName);
      return $value;  
   }
   
   /* setAttribute($node as node,$attrName as string,$value as string)
    * $node: uzel v XML
    * $attrName: nzev atributu
    * $value: hodnota atributu
    * zmn hodnotu atrubutu v uzlu
    * */
   public function setAttribute($node,$attrName,$value){
   	$node->setAttribute($attrName,$value);
   }
   
   public function deleteServer($name){
   	$servers = $this->getNode('servers');
   	foreach($servers as $key){
   		$children = $this->getNode('server');
   		foreach($children as $child){
   		  if($this->getAttribute($child,'Name') == $name){
   		  	$key->removeChild($child);
   		  }	
   		}
   	}
   }
   
   /* saveConf()
    * ulo nov/zmnn XML dokument
    * */
   public function saveConf()
   {
       $this->domConf->save("config.xml");
   } 
} 

?>
